function X = LoopMC(edgeStruct,nodeBelLBP, edgeBelLBP,beta, X_BASIS, burnin, X_init)
%Markov Chain for sampling generalized loops
X=X_init;
for t = 1: burnin
    pick_idx = randi([1,size(X_BASIS,2)], 1);
    Y = xor(X, X_BASIS(:,pick_idx));
    if isLoop(Y,edgeStruct)
        prob_flip = min([1, abs(LoopTerm(edgeStruct, nodeBelLBP, edgeBelLBP, beta, Y)/LoopTerm(edgeStruct, nodeBelLBP, edgeBelLBP, beta, X))]);
        coin = rand(1);
        if coin < prob_flip
            X = Y;
        end
    end
end
end

function flag = isLoop(X, edgeStruct)
%Checks if X is a generalized loop.
newEdgeEnds = edgeStruct.edgeEnds(X == 1, :);
newadj = zeros(edgeStruct.nNodes);
for i = 1: size(newEdgeEnds, 1)
    newadj(newEdgeEnds(i,1), newEdgeEnds(i,2)) = 1;
    newadj(newEdgeEnds(i,2), newEdgeEnds(i,1)) = 1;
end
newDegree = sum(newadj, 2);
if sum(newDegree == 1) > 0
    flag = 0;
else
    flag = 1;
end
end